package restapi.crud;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Optional;


public interface MatchRepository extends JpaRepository<MatchEntity, Long> {
    List<MatchEntity> findAllByUserId1OrUserId2(long u1, long u2);
    List<MatchEntity> findAllByUserId1AndUserId2AndOutdated(long u1, long u2, boolean outdated);
    List<MatchEntity> findTop10ByUserId1OrUserId2OrderByIdDesc(long u1, long u2);
    @Query("SELECT m FROM MatchEntity m WHERE (m.userId1 = ?1 OR m.userId2 = ?1) AND m.outdated = ?2")
    List<MatchEntity> findAllByUserIDAndOutdated(long id, Boolean outdated);
    @Query("SELECT m FROM MatchEntity m WHERE (m.userId1 = ?1 OR m.userId2 = ?1) AND m.state = ?2")
    List<MatchEntity> findAllByUserIDAndState(long id, String state);
}