package restapi.crud;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Optional;

public interface MatchRequestRepository extends JpaRepository<MatchRequestEntity, Long> {
    Optional<MatchRequestEntity> findByMatchId(long matchId);
    List<MatchRequestEntity> findAllBySenderOrReceiver(long u1, long u2);
    List<MatchRequestEntity> findAllBySender(long u1);
    List<MatchRequestEntity> findAllByReceiver(long u1);
    List<MatchRequestEntity> findAllBySenderAndState(long u1, String state);
    List<MatchRequestEntity> findAllByReceiverAndState(long u1, String state);
    @Query("SELECT m FROM MatchRequestEntity m WHERE (m.sender = ?1 OR m.receiver = ?1) AND m.state = ?2")
    List<MatchRequestEntity> findAllByUserIDAndState(long id, String state);
}
