package restapi.crud;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Optional;

public interface RequestRepository extends JpaRepository<RequestEntity, Long> {
    List<RequestEntity> findAllBySenderIDOrReceiverID(long sender, long receiver);

    @Query("SELECT r FROM RequestEntity r WHERE (r.senderID = ?1 OR r.receiverID = ?1) AND r.state = ?2")
    List<RequestEntity> findAllByUserIDAndState(long id, String state);

    List<RequestEntity> findAllBySenderIDAndState(long sender, String state);

    Optional<RequestEntity> findBySenderIDAndReceiverID(long sender, long receiver);

    boolean existsBySenderIDAndReceiverID(long sender, long receiver);
}
