package restapi.crud;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.checkerframework.common.aliasing.qual.Unique;

import javax.persistence.*;

@Entity
@Table(name = "user_data")
@NoArgsConstructor
public class UserEntity {
    @Id
    @GeneratedValue(strategy= GenerationType.AUTO)
    @Getter
    long id;

    @Column(name = "username")
    @Unique
    @Getter
    @Setter
    String username;

    @Column(name = "password")
    @Getter
    @Setter
    String password;

    @Column(name = "name")
    @Getter
    @Setter
    String name;

    @Column(name = "about")
    @Getter
    @Setter
    String about;

    @Column(name = "phone")
    @Unique
    @Getter
    @Setter
    String phone;

    @Column(name = "country")
    @Getter
    @Setter
    String country;

    @Column(name = "email")
    @Unique
    @Getter
    @Setter
    String email;

    @Column(name = "token")
    @Getter
    @Setter
    String token;

    @Column(name = "last_connection")
    @Getter
    @Setter
    String lastConnection;

    @Column(name = "avatar", columnDefinition = "integer default 7")
    @Getter
    @Setter
    int avatar;

    public UserEntity(@Unique String username, String password) {
        this.username = username;
        this.password = password;
    }
}
