package restapi.utils.services.date;

import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

/**
 * Provides the current date.
 *
 * @author jerome
 */
public interface DateService {

    /**
     * @return current date at the moment of the call
     */
    DateTime now();

    /**
     * @return current date at the moment of the call
     */
    String nowToString();

    /**
     * @param dateTime in DateTime format
     * @return dateTime in String format
     */
    String dateToString(DateTime dateTime);

    /**
     * @param date in String format
     * @return dateTime in DateTime format
     */
    DateTime dateFromString(String date);

    /**
     * @param dateTime date to compare with
     * @param min minutes that have to have past
     * @return if datetime is older than minutes
     */
    boolean isOlderThan(DateTime dateTime, int min);


    /**
     * @param dateTime date to compare with in format String
     * @param min minutes that have to have past
     * @return if datetime is older than minutes
     */
    boolean isOlderThan(String dateTime, int min);
}
