package restapi.utils.swagger;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

@AllArgsConstructor
@NoArgsConstructor
@Schema(name = "User")
public class SwaggerUser {
    @Getter
    @Setter
    @Schema(example = "13")
    private long id;
    @Getter
    @Setter
    @Schema(example = "janedoe")
    private String username;
    @Getter
    @Setter
    @Schema(example = "Jane Doe")
    private String name;
    @Getter
    @Setter
    @Schema(example = "Something about me")
    private String about;
    @Getter
    @Setter
    @Schema(example = "+34678678678")
    private String phone;
    @Getter
    @Setter
    @Schema(example = "ES")
    private String country;
    @Getter
    @Setter
    @Schema(example = "janedoe@gmail.com")
    private String email;
    @Getter
    @Setter
    @Schema(example = "7")
    private int avatar;
    @Getter
    @Setter
    @Schema(example = "true")
    private boolean online;
}

/*

@AllArgsConstructor
@NoArgsConstructor
public class SwaggerUser {
    long id = 13;
    String username = "janedoe";
    String name = "Jane Doe";
    String about = "Something about me";
    String phone = "+34678678678";
    String country = "ES";
    String email = "janedoe@gmail.com";
    int avatar = 7;
    boolean online = true;
 */