package restapi.junit;

import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import restapi.location.LocationDTO;
import restapi.services.LocationService;
import restapi.services.UserService;

public class LocationTest {

    private final LocationDTO location1 = new LocationDTO(41.421506, 1.943601, "");
    private final LocationDTO location2 = new LocationDTO(41.421229, 1.942874, "");
    private final LocationDTO location3 = new LocationDTO(41.421784, 1.942298, "");

    @Test
    public void samePointDistanceZero() {
        assert 0 == LocationService.distance(location1.getLatitude(), location1.getLongitude(), 0, location1.getLatitude(), location1.getLongitude(), 0);
    }

    @Test
    public void similarPointDistanceSmall() {
        assert 100 > LocationService.distance(location1.getLatitude(), location1.getLongitude(), 0, location2.getLatitude(), location2.getLongitude(), 0);
    }

    @Test
    public void similarPointDistanceSmallWrong() {
        assert !(100 < LocationService.distance(location1.getLatitude(), location1.getLongitude(), 0, location2.getLatitude(), location2.getLongitude(), 0));
    }

    @Test
    public void farPointDistanceSmall() {
        assert 100 < LocationService.distance(location1.getLatitude(), location1.getLongitude(), 0, location3.getLatitude(), location3.getLongitude(), 0);
    }
}
