package restapi.junit;

import org.junit.Assert;
import org.junit.Test;
import restapi.utils.services.phone.PhoneNumberService;

import java.util.Arrays;
import java.util.List;

public class PhoneNumberTest {
    private final String expectedMobileNumber = "+4746205615";
    private final List<String> successMobileNumbers =
            Arrays.asList(
                    "46205615",
                    "004746205615",
                    "+4746205615",
                    "4746205615",
                    "46205615",
                    "+47 46205615",
                    "462 05 615");
    private final List<String> failMobileNumbers = Arrays.asList("abcdsds3434", "abcdsds343?#4", "21448410", "9946739087");

    private final PhoneNumberService phoneNumberService = new PhoneNumberService();

    @Test
    public void e164FormattedMobileNumbersSuccessCase() throws Exception {
        for (String mobileNumber : successMobileNumbers) {
            Assert.assertEquals(
                    expectedMobileNumber,
                    (phoneNumberService.getFormattedNumberWithCountry(mobileNumber, "NO")));
        }
    }

    @Test(expected = Exception.class)
    public void e164FormattedMobileNumbersFailCase() throws Exception {
        for (String mobileNumber : failMobileNumbers) {
            phoneNumberService.getFormattedNumberWithCountry(mobileNumber, "NO");
        }
    }
}
