export interface DataClass {
    toJsonString(): string;
    toDictionary(): {};
}

export class UserData implements DataClass {
    username: string;
    password: string;
    phone: string;
    email: string;
    country: string;
    name: string;
    about: string;
    authUID: string;
    constructor() { }
    toJsonString(): string {
        return '{"username":"' + this.username + '","email":"' + this.email + '","phone":"' + this.phone
            + '","password":"' + this.password + '","country":"' + this.country + '","name":"' + this.name
            + '","about":"' + this.about + '","authUID":"' + this.authUID + '"}';
    }
    toDictionary(): {} {
        var ret = {};
        if (this.password) {
            ret['password'] = this.password;
        } if (this.username) {
            ret['username'] = this.username;
        } if (this.email) {
            ret['email'] = this.email;
        } if (this.phone) {
            ret['phone'] = this.phone;
        } if (this.country) {
            ret['country'] = this.country;
        } if (this.name) {
            ret['name'] = this.name;
        } if (this.about) {
            ret['about'] = this.about;
        } if (this.authUID) {
            ret['authUID'] = this.authUID;
        }
        return ret;
    }
}

export class ContactPrefData implements DataClass {
    range: number;
    blocked: boolean;
    constructor(
        private contactId: number
    ) { }
    toJsonString(): string {
        var s = '{"contactId":' + this.contactId;
        if (this.range) { s += ',"range":' + this.range }
        if (this.blocked != null) { s += ',"blocked":' + this.blocked; }
        s += '}'
        return s;
    }
    toDictionary(): {} {
        var ret = {};
        if (this.contactId) {
            ret['contactId'] = this.contactId;
        } if (this.range) {
            ret['range'] = this.range;
        } if (this.blocked != null) {
            ret['blocked'] = this.blocked;
        }
        return ret;
    }
}

export class LocationData implements DataClass {
    constructor(
        private latitude: string,
        private longitude: string,
        private username: string,
        //private tokenFire: string
    ) { }
    toJsonString(): string {
        return '{"longitude":' + this.longitude + ',"latitude":' + this.latitude + ',"username":"' + this.username + '"}';//'","tokenFire":"' + this.tokenFire + '"}';
    }
    toDictionary(): {} {
        var ret = {};
        if (this.longitude) {
            ret['longitude'] = this.longitude;
        } if (this.longitude) {
            ret['latitude'] = this.latitude;
        } if (this.username) {
            ret['username'] = this.username;
        }/* if (this.tokenFire) {
            ret['tokenFire'] = this.tokenFire;
        }//*/
        return ret;
    }
}

export class MatchData implements DataClass {
    id: number;
    user: UserData;
    distanceRange: string;
    date: string;

    constructor() { }
    toJsonString(): string {
        return '{"user":' + this.user.toJsonString() + ',"range":"' + this.distanceRange + '","date":"' + this.date + '"}';
    }
    toDictionary(): {} {
        var ret = {};
        if (this.user) {
            ret['user'] = this.user.toDictionary();
        } if (this.distanceRange) {
            ret['range'] = this.distanceRange;
        } if (this.date) {
            ret['date'] = this.date;
        }/* if (this.tokenFire) {
            ret['tokenFire'] = this.tokenFire;
        }//*/
        return ret;
    }
}

export class MessageData implements DataClass {
    sender: string;
    reciever: string;
    date: string;
    content: string;

    constructor() { }
    toJsonString(): string {
        return '{"sender":' + this.sender + ',"reciever":"' + this.reciever + '","date":"' + this.date + '","content":"' + this.content + '"}';
    }
    toDictionary(): {} {
        var ret = {};
        if (this.sender) {
            ret['sender'] = this.sender;
        } if (this.reciever) {
            ret['reciever'] = this.reciever;
        } if (this.date) {
            ret['date'] = this.date;
        } if (this.content) {
            ret['content'] = this.content;
        }
        return ret;
    }
}