import { AfterContentInit, Component, OnInit } from '@angular/core';
import { parsePhoneNumber } from 'libphonenumber-js/mobile';
import { FirebaseAuthService } from 'src/app/providers/server/firebase-auth.service';
import { StorageService } from 'src/app/providers/storage.service';


@Component({
  selector: 'app-phone-signup',
  templateUrl: './phone-signup.page.html',
  styleUrls: ['./phone-signup.page.scss'],
})
export class PhoneSignupPage implements OnInit, AfterContentInit {

  textMessage = 'Sign in with your phone number to find all your contacts on nearme';

  phone: string = '';
  phoneValid = true;

  countries: any;
  country: any = {"name": "Spain","dial_code": "+34","code": "ES"};

  constructor(
    private authService: FirebaseAuthService,
    private storage: StorageService
  ) {
  }

  ngOnInit() {
    this.readJsonData();
    this.storage.remove('phoneNumber');
    this.storage.remove('countryCode');
  }

  ngAfterContentInit() {
  }

  readJsonData() {
    fetch("../../../assets/res/CountryCodes.json").then(res => res.json()).then(json => {
      this.countries = json;
    });
  }

  phoneNumberValidator() {
    const phoneNumber = parsePhoneNumber(this.phone, this.country.code);
    this.phoneValid = phoneNumber.isValid()
  }

  onSignup() {
    this.storage.set('phoneNumber', this.phone);
    this.storage.set('country', this.country);
    this.authService.signInWithPhoneNumber(this.country.dial_code + this.phone);
  }

  compareFn(e1: any, e2: any): boolean { return e1 && e2 ? e1.code == e2.code : e1 == e2; }

}
