import { Component, OnInit } from '@angular/core';
import { CommonUtilsService } from 'src/app/providers/common-utils.service';
import { ApiService } from 'src/app/providers/server/api.service';
import { StorageService } from 'src/app/providers/storage.service';

@Component({
  selector: 'app-old-matches',
  templateUrl: './old-matches.page.html',
  styleUrls: ['./old-matches.page.scss'],
})
export class OldMatchesPage implements OnInit {

  notificationMatchesOld: any[];

  constructor(
    private storage: StorageService,
    private api: ApiService,
    private utils: CommonUtilsService
  ) { }

  ngOnInit() {
    this.loadMatches();
  }

  loadMatches() {

    this.storage.get('authToken').then(token => {
      this.api.getFulfilledMatches(token).subscribe({
        next: response => {
          this.notificationMatchesOld = response.matches;
        }
      });
    });
  }

}
