import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';

import { TabsPage } from './tabs.page';

const routes: Routes = [
  {
    path: '',
    component: TabsPage,
    children: [
      {
        path: 'user',
        loadChildren: () => import('../user-detail/user-detail.module').then(m => m.UserDetailPageModule)
      },
      {
        path: 'contacts',
        children: [
          {
            path: '',
            loadChildren: () => import('../contact-list/contact-list.module').then(m => m.ContactListPageModule)
          },
          {
            path: 'detail',
            loadChildren: () => import('../contact-detail/contact-detail.module').then(m => m.ContactDetailPageModule)
          }
        ]
      },
      {
        path: 'requests',
        children: [
          {
            path: '',
            loadChildren: () => import('../friend-requests/friend-requests.module').then(m => m.FriendRequestsPageModule)
          },
          {
            path: 'find',
            loadChildren: () => import('../find-friends/find-friends.module').then(m => m.FindFriendsPageModule)
          }
        ]
      },
      {
        path: 'location',
        children: [
          {
            path: '',
            loadChildren: () => import('../location/location.module').then(m => m.LocationPageModule)
          },
          {
            path: 'old',
            loadChildren: () => import('../old-matches/old-matches.module').then(m => m.OldMatchesPageModule)
          }
        ]
      },
      {
        path: '',
        redirectTo: '/tabs/location',
        pathMatch: 'full'
      }
    ]
  }
];

@NgModule({
  imports: [RouterModule.forChild(routes)],
  exports: [RouterModule],
})
export class TabsPageRoutingModule { }
