import { Injectable } from '@angular/core';
import { Router } from '@angular/router';
import { StorageService } from '../storage.service';
import { WebSocketService } from '../server/web-socket.service';

@Injectable({
  providedIn: 'root'
})
export class LogoutService {

  constructor(
    public storage: StorageService,
    public router: Router,
    public webSocketAPI: WebSocketService
  ) { }

  logout() {
    this.storage.remove('authToken');
    this.webSocketAPI.disconnect();
    this.router.navigate(['login'], { replaceUrl: true });
  }

}
