import { Injectable } from '@angular/core';
import { LocalNotifications } from '@capacitor/local-notifications'

@Injectable({
  providedIn: 'root'
})
export class LocalNotificationService {
  id = 0;

  constructor() { }

  requestPermisions() {
    LocalNotifications.checkPermissions().then( permissionStatus =>{
      if(!permissionStatus.display) {
        LocalNotifications.requestPermissions()
      }
    })
  }

  newMatch(username: string, name: string) {
    LocalNotifications.schedule({
      notifications:
      [
        {
          title: name,
          body: '@' + username + ' is near! Open the app to connect',
          id: ++this.id,
        }
      ]
    });
  }

  wantsToConnect(username: string, name: string) {
    LocalNotifications.schedule({
      notifications:
      [
        {
          title: name,
          body: '@' + username + ' wants to meet',
          id: ++this.id,
        }
      ]
    });
  }
}
