import { Injectable } from '@angular/core';
import { Capacitor } from '@capacitor/core';
import { PushNotificationSchema, Token, ActionPerformed, PushNotifications } from '@capacitor/push-notifications';
import { Router } from '@angular/router';
import { StorageService } from '../storage.service';
import { Platform } from '@ionic/angular';

@Injectable({
  providedIn: 'root'
})
export class FirebaseCloudMessagingService {
  /*
  allowPush: boolean;
  allowPersonal: boolean;
  token: string | null = null;

  constructor(
    private storage: StorageService,
    platform: Platform
  ) {
    platform.ready().then(async () => {
      try {
        await this.initFcm();
      } catch (e) {
        console.log('Something went wrong during initialization: ', e);
      }
    });

    storage.get('allowPush').then(pushFlag => this.allowPush = pushFlag != null ? JSON.parse(pushFlag) : false);
    storage.get('allowPersonal').then(personalFlag => this.allowPersonal = personalFlag != null ? JSON.parse(personalFlag) : false);
  }

  async initFcm(): Promise<void> {
    await cordova.plugins.firebase.messaging.requestPermission();
    this.token = await cordova.plugins.firebase.messaging.getToken();

    cordova.plugins.firebase.messaging.onTokenRefresh(async () => {
      console.log('Token updated');
      this.token = await cordova.plugins.firebase.messaging.getToken();
    });

    cordova.plugins.firebase.messaging.onMessage((payload: any) => {
      console.log('New foreground message: ', payload);
      this.handleNotification(payload);
    });

    cordova.plugins.firebase.messaging.onBackgroundMessage((payload: any) => {
      console.log('New background message: ', payload);
      this.handleNotification(payload);
    });

    this.onChange();
    this.onPmChange();
  }

  register(): void {
    if (this.token !== null) {
      const formData = new FormData();
      formData.append('token', this.token);
      this.http.post(`${environment.serverURL}/register`, formData)
        .pipe(timeout(10000))
        .subscribe(() => localStorage.setItem('allowPersonal', JSON.stringify(this.allowPersonal)),
          _ => this.allowPersonal = !this.allowPersonal);
    }
  }

  unregister(): void {
    if (this.token !== null) {
      const formData = new FormData();
      formData.append('token', this.token);
      this.http.post(`${environment.serverURL}/unregister`, formData)
        .pipe(timeout(10000))
        .subscribe(() => localStorage.setItem('allowPersonal', JSON.stringify(this.allowPersonal)),
          _ => this.allowPersonal = !this.allowPersonal);
    }
  }

  onChange(): void {
    localStorage.setItem('allowPush', JSON.stringify(this.allowPush));

    if (this.allowPush) {
      cordova.plugins.firebase.messaging.subscribe(this.TOPIC_NAME);
    } else {
      cordova.plugins.firebase.messaging.unsubscribe(this.TOPIC_NAME);
    }
  }

  onPmChange(): void {
    if (this.allowPersonal) {
      this.register();
    } else {
      this.unregister();
    }
  }

  handleNotification(data: any): void {
    if (!data.text) {
      return;
    }

    this.items.splice(0, 0, {id: data.id, text: data.text});

    // only keep the last 5 entries
    if (this.items.length > 5) {
      this.items.pop();
    }

    this.changeDetectorRef.detectChanges();
  }

  //*/

  //*
    constructor(private router: Router) { }
  
    initPush() {
      if (Capacitor.platform !== 'web') {
        this.registerPush();
      }
    }
  
    private registerPush() {
      PushNotifications.requestPermissions().then((permission) => {
        if (permission.receive == 'granted') {
          // Register with Apple / Google to receive push via APNS/FCM
          PushNotifications.register();
        } else {
          // No permission for push granted
        }
      });
  
      PushNotifications.addListener('registration',
        (token: Token) => {
          console.log('My token: ' + JSON.stringify(token));
        }
      );
  
      PushNotifications.addListener('registrationError', (error: any) => {
        console.log('Error: ' + JSON.stringify(error));
      });
  
      PushNotifications.addListener('pushNotificationReceived',
        async (notification: PushNotificationSchema) => {
          console.log('Push received: ' + JSON.stringify(notification));
        }
      );
  
      PushNotifications.addListener('pushNotificationActionPerformed',
        async (notification: ActionPerformed) => {
          const data = notification.notification.data;
          console.log('Action performed: ' + JSON.stringify(notification.notification));
          if (data.detailsId) {
            this.router.navigateByUrl(`/home/${data.detailsId}`);
          }
        }
      );
    }//*/
}